# Copyright (c) 2000-2011, JPackage Project
# All rights reserved.
#
# Redistribution and use in source and binary forms, with or without
# modification, are permitted provided that the following conditions
# are met:
#
# 1. Redistributions of source code must retain the above copyright
#    notice, this list of conditions and the following disclaimer.
# 2. Redistributions in binary form must reproduce the above copyright
#    notice, this list of conditions and the following disclaimer in the
#    documentation and/or other materials provided with the
#    distribution.
# 3. Neither the name of the JPackage Project nor the names of its
#    contributors may be used to endorse or promote products derived
#    from this software without specific prior written permission.
#
# THIS SOFTWARE IS PROVIDED BY THE COPYRIGHT HOLDERS AND CONTRIBUTORS
# "AS IS" AND ANY EXPRESS OR IMPLIED WARRANTIES, INCLUDING, BUT NOT
# LIMITED TO, THE IMPLIED WARRANTIES OF MERCHANTABILITY AND FITNESS FOR
# A PARTICULAR PURPOSE ARE DISCLAIMED. IN NO EVENT SHALL THE COPYRIGHT
# OWNER OR CONTRIBUTORS BE LIABLE FOR ANY DIRECT, INDIRECT, INCIDENTAL,
# SPECIAL, EXEMPLARY, OR CONSEQUENTIAL DAMAGES (INCLUDING, BUT NOT
# LIMITED TO, PROCUREMENT OF SUBSTITUTE GOODS OR SERVICES; LOSS OF USE,
# DATA, OR PROFITS; OR BUSINESS INTERRUPTION) HOWEVER CAUSED AND ON ANY
# THEORY OF LIABILITY, WHETHER IN CONTRACT, STRICT LIABILITY, OR TORT
# (INCLUDING NEGLIGENCE OR OTHERWISE) ARISING IN ANY WAY OUT OF THE USE
# OF THIS SOFTWARE, EVEN IF ADVISED OF THE POSSIBILITY OF SUCH DAMAGE.
#

%define section free

%define jspspec 2.2
%define major_version 7
%define minor_version 0
%define micro_version 22
%define packdname apache-tomcat-%{major_version}.%{minor_version}.%{micro_version}-src
%define servletspec 3.0
%define elspec 2.2
%define tcuid 91

# FHS 2.3 compliant tree structure - http://www.pathname.com/fhs/2.3/
%define basedir %{_var}/lib/%{name}
%define appdir %{basedir}/webapps
%define bindir %{_datadir}/%{name}/bin
%define confdir %{_sysconfdir}/%{name}
%define homedir %{_datadir}/%{name}
%define libdir %{_javadir}/%{name}
%define logdir %{_var}/log/%{name}
%define cachedir %{_var}/cache/%{name}
%define tempdir %{cachedir}/temp
%define workdir %{cachedir}/work
%define _initrddir %{_sysconfdir}/init.d

Name: tomcat7
Epoch: 0
Version: %{major_version}.%{minor_version}.%{micro_version}
Release: 1%{?dist}
Summary: Apache Servlet/JSP Engine, RI for Servlet %{servletspec}/JSP %{jspspec} API

Group: Networking/Daemons
License: ASL 2.0
URL: http://tomcat.apache.org/
Source0: http://www.apache.org/dist/tomcat/tomcat-7/v%{version}/src/%{packdname}.tar.gz
Source1: %{name}-%{major_version}.%{minor_version}.conf
Source2: %{name}-%{major_version}.%{minor_version}.init
Source3: %{name}-%{major_version}.%{minor_version}.sysconfig
Source4: %{name}-%{major_version}.%{minor_version}.wrapper
Source5: %{name}-%{major_version}.%{minor_version}.logrotate
Source6: %{name}-%{major_version}.%{minor_version}-digest.script
Source7: %{name}-%{major_version}.%{minor_version}-tool-wrapper.script
Source8: %{name}-%{major_version}.%{minor_version}.starter
Source11: http://www.apache.org/dist/commons/pool/source/commons-pool-1.5.6-src.tar.gz
Source12: http://www.apache.org/dist/commons/dbcp/source/commons-dbcp-1.4-src.tar.gz
Source13: http://www.apache.org/dist/tomcat/tomcat-connectors/native/1.1.22/source/tomcat-native-1.1.22-src.tar.gz
Source14: http://www.apache.org/dist/commons/daemon/source/commons-daemon-1.0.7-native-src.tar.gz
Source15: http://www.apache.org/dist/commons/logging/source/commons-logging-1.1.1-src.tar.gz
Source21: http://repo2.maven.org/maven2/org/apache/tomcat/tomcat-annotations-api/7.0.22/tomcat-annotations-api-7.0.22.pom
Source22: http://repo2.maven.org/maven2/org/apache/tomcat/tomcat-api/7.0.22/tomcat-api-7.0.22.pom
Source23: http://repo2.maven.org/maven2/org/apache/tomcat/tomcat-catalina/7.0.22/tomcat-catalina-7.0.22.pom
Source24: http://repo2.maven.org/maven2/org/apache/tomcat/tomcat-catalina-ant/7.0.22/tomcat-catalina-ant-7.0.22.pom
Source25: http://repo2.maven.org/maven2/org/apache/tomcat/tomcat-catalina-ha/7.0.22/tomcat-catalina-ha-7.0.22.pom
Source26: http://repo2.maven.org/maven2/org/apache/tomcat/tomcat-catalina-jmx-remote/7.0.22/tomcat-catalina-jmx-remote-7.0.22.pom
Source27: http://repo2.maven.org/maven2/org/apache/tomcat/tomcat-catalina-ws/7.0.22/tomcat-catalina-ws-7.0.22.pom
Source28: http://repo2.maven.org/maven2/org/apache/tomcat/tomcat-coyote/7.0.22/tomcat-coyote-7.0.22.pom
Source29: http://repo2.maven.org/maven2/org/apache/tomcat/tomcat-dbcp/7.0.22/tomcat-dbcp-7.0.22.pom
Source30: http://repo2.maven.org/maven2/org/apache/tomcat/tomcat-el-api/7.0.22/tomcat-el-api-7.0.22.pom
Source31: http://repo2.maven.org/maven2/org/apache/tomcat/tomcat-i18n-es/7.0.22/tomcat-i18n-es-7.0.22.pom
Source32: http://repo2.maven.org/maven2/org/apache/tomcat/tomcat-i18n-fr/7.0.22/tomcat-i18n-fr-7.0.22.pom
Source33: http://repo2.maven.org/maven2/org/apache/tomcat/tomcat-i18n-ja/7.0.22/tomcat-i18n-ja-7.0.22.pom

Source35: http://repo2.maven.org/maven2/org/apache/tomcat/tomcat-jasper/7.0.22/tomcat-jasper-7.0.22.pom
Source36: http://repo2.maven.org/maven2/org/apache/tomcat/tomcat-jasper-el/7.0.22/tomcat-jasper-el-7.0.22.pom
Source37: http://repo2.maven.org/maven2/org/apache/tomcat/tomcat-jdbc/7.0.22/tomcat-jdbc-7.0.22.pom
Source38: http://repo2.maven.org/maven2/org/apache/tomcat/tomcat-jsp-api/7.0.22/tomcat-jsp-api-7.0.22.pom
Source39: http://repo2.maven.org/maven2/org/apache/tomcat/tomcat-juli/7.0.22/tomcat-juli-7.0.22.pom
Source40: http://repo2.maven.org/maven2/org/apache/tomcat/tomcat-servlet-api/7.0.22/tomcat-servlet-api-7.0.22.pom
Source41: http://repo2.maven.org/maven2/org/apache/tomcat/tomcat-tribes/7.0.22/tomcat-tribes-7.0.22.pom
Source42: http://repo2.maven.org/maven2/org/apache/tomcat/tomcat-util/7.0.22/tomcat-util-7.0.22.pom

Patch0: %{name}-build.patch

BuildRoot: %{_tmppath}/%{name}-%{version}-%{release}-root
BuildArch: noarch

BuildRequires: ant >= 0:1.8
BuildRequires: ant-trax
BuildRequires: ecj3
BuildRequires: findutils
BuildRequires: apache-commons-collections
BuildRequires: apache-commons-collections-tomcat5
BuildRequires: apache-commons-daemon
BuildRequires: apache-commons-dbcp-tomcat5
BuildRequires: apache-commons-pool-tomcat5
BuildRequires: excalibur-avalon-framework
BuildRequires: excalibur-avalon-logkit
BuildRequires: java-devel >= 0:1.6.0
BuildRequires: jpackage-utils >= 0:1.7.5
BuildRequires: junit
BuildRequires: log4j
BuildRequires: servletapi4
BuildRequires: wsdl4j
Requires(pre): shadow-utils
Requires(pre): shadow-utils
Requires: apache-commons-daemon
Requires: apache-commons-logging
Requires: java >= 0:1.6.0
Requires: procps
Requires: %{name}-lib = %{epoch}:%{version}-%{release}
Requires(post): /sbin/chkconfig
Requires(preun): /sbin/chkconfig
Requires(post): /lib/lsb/init-functions
Requires(preun): /lib/lsb/init-functions
Requires(post):    jpackage-utils >= 0:1.7.5
Requires(postun):  jpackage-utils >= 0:1.7.5

%description
Tomcat is the servlet container that is used in the official Reference
Implementation for the Java Servlet and JavaServer Pages technologies.
The Java Servlet and JavaServer Pages specifications are developed by
Sun under the Java Community Process.

Tomcat is developed in an open and participatory environment and
released under the Apache Software License version 2.0. Tomcat is intended
to be a collaboration of the best-of-breed developers from around the world.

%package admin-webapps
Group: System Environment/Applications
Summary: The host-manager and manager web applications for Apache Tomcat
Requires: %{name} = %{epoch}:%{version}-%{release}

%description admin-webapps
The host-manager and manager web applications for Apache Tomcat.

%package docs-webapp
Group: System Environment/Applications
Summary: The docs web application for Apache Tomcat
Requires: %{name} = %{epoch}:%{version}-%{release}

%description docs-webapp
The docs web application for Apache Tomcat.

%package el-%{elspec}-api
Summary: Expression Language v2.2 API
Group: Development/Libraries/Java
Provides: el_2_2_api = %{epoch}:%{version}-%{release}
Provides: el_api = 0:2.2
Requires(preun):  %{_sbindir}/update-alternatives
Requires(post):  %{_sbindir}/update-alternatives

%description el-%{elspec}-api
Expression Language 1.0.

%package javadoc
Group: Documentation
Summary: Javadoc generated documentation for Apache Tomcat

%description javadoc
Javadoc generated documentation for Apache Tomcat.

%package jsp-%{jspspec}-api
Group: Internet/WWW/Dynamic Content
Summary: Apache Tomcat JSP API implementation classes
Provides: jsp = %{jspspec}
Provides: jsp22
Requires: %{name}-servlet-%{servletspec}-api = %{epoch}:%{version}-%{release}
Requires(post): %{_sbindir}/update-alternatives
Requires(postun): %{_sbindir}/update-alternatives

%description jsp-%{jspspec}-api
Apache Tomcat JSP API implementation classes.

%package lib
Group: Development/Compilers
Summary: Libraries needed to run the Tomcat Web container
Requires: %{name}-jsp-%{jspspec}-api = %{epoch}:%{version}-%{release}
Requires: %{name}-servlet-%{servletspec}-api = %{epoch}:%{version}-%{release}
Requires: %{name}-el-%{elspec}-api = %{epoch}:%{version}-%{release}
Requires: ecj3
Requires: %{_javadir}/ecj3.jar
Requires: apache-commons-collections-tomcat5
Requires: apache-commons-dbcp-tomcat5
Requires: apache-commons-pool-tomcat5
Requires(preun): coreutils

%description lib
Libraries needed to run the Tomcat Web container.

%package servlet-%{servletspec}-api
Group: Internet/WWW/Dynamic Content
Summary: Apache Tomcat Servlet API implementation classes
Provides: servlet = %{servletspec}
Provides: servlet7
Provides: servlet30
Requires(post): %{_sbindir}/update-alternatives
Requires(postun): %{_sbindir}/update-alternatives

%description servlet-%{servletspec}-api
Apache Tomcat Servlet API implementation classes.

%package webapps
Group: System Environment/Applications
Summary: The ROOT and examples web applications for Apache Tomcat
Requires: %{name} = %{epoch}:%{version}-%{release}
Requires(post): jakarta-taglibs-standard >= 0:1.1

%description webapps
The ROOT and examples web applications for Apache Tomcat.

%prep
%setup -q -c -T -a 0
for j in $(find . -name "*.jar"); do
    mv $j $j.no
done

# remove pre-built binaries and windows files
find . -type f \( \
    -name "*.bat" -o \
    -name "*.class" -o \
    -name "*.gz" -o \
    -name "*.jar" -o \
    -name "*.war" -o \
    -name "*.zip" -o \
    -name "Thumbs.db" \) | xargs -t %{__rm}
pushd %{packdname}
%patch0 -p0 -b .sav0

popd

%build
export CLASSPATH=
export OPT_JAR_LIST="ant/ant-trax"
pushd %{packdname}
    mkdir -p commons/pool/source/
    ln -s %{SOURCE11} commons/pool/source/commons-pool-1.5.6-src.tar.gz
    mkdir -p commons/dbcp/source/
    ln -s %{SOURCE12} commons/dbcp/source/commons-dbcp-1.4-src.tar.gz
    mkdir -p tomcat/tomcat-connectors/native/1.1.22/source/
    ln -s %{SOURCE13} tomcat/tomcat-connectors/native/1.1.22/source/tomcat-native-1.1.22-src.tar.gz
    mkdir -p commons/daemon/source/
    ln -s %{SOURCE14} commons/daemon/source/commons-daemon-1.0.7-native-src.tar.gz
    mkdir -p commons/logging/source/
    ln -s %{SOURCE15} commons/logging/source/commons-logging-1.1.1-src.tar.gz
    %{ant} -Dbase.path="." \
        -Dbase-apache.loc.1=file://$(pwd) \
        -Dbase-apache.loc.2=file://$(pwd) \
        -Dcommons-daemon.jar=$(build-classpath commons-daemon) \
        -Djdt.jar=$(build-classpath ecj3) \
        -Djaxrpc-lib.jar=$(build-classpath geronimo-jaxrpc-1.1-api) \
        -Dwsdl4j-lib.jar=$(build-classpath wsdl4j) \
        -Davalon-framework.jar=$(build-classpath avalon-framework) \
        -Dlog4j.jar=$(build-classpath log4j) \
        -Dlogkit.jar=$(build-classpath avalon-logkit) \
        -Dservletapi.jar=$(build-classpath servlet_2_3_api) \
        -Dskip.installer=true \
	deploy javadoc extras embed release

#        -Dbuild.compiler="modern" \
#       -Dcommons-collections.jar="$(build-classpath commons-collections)" \
#       -Dcommons-daemon.native.src.tgz=%{SOURCE11} \
#       -Djasper-jdt.jar="$(build-classpath ecj3)" \
#       -Dtomcat-dbcp.jar="HACK" \
#       -Dversion="%{version}" \
#       -Dversion.build="%{micro_version}"

#       -Dtomcat-native.tar.gz="HACK" \
#       -Dcommons-daemon.native.src.tgz="HACK" \

#   %{ant} -f extras.xml \
#       -Dcommons-logging.home=$(pwd) \
#       -Dcommons-logging-src.loc=file://%{SOURCE13} \
#       -Davalon-framework.home=$(pwd) \
#       -Davalon-framework.loc=file://$(build-classpath avalon-framework) \
#       -Dlog4j.home=$(pwd) \
#       -Dlog4j.loc=file://$(build-classpath log4j) \
#       -Dlogkit.home=$(pwd) \
#       -Dlogkit.loc=file://$(build-classpath avalon-logkit) \
#       -Dservletapi.home=$(pwd) \
#       -Dservletapi.loc=file://$(build-classpath geronimo-servlet-2.5-api) \
#       -Djaxrpc-lib.home=$(pwd) \
#       -Djaxrpc-lib.loc=file://$(build-classpath geronimo-jaxrpc-1.1-api) \
#       -Dwsdl4j-lib.home=$(pwd) \
#       -Dwsdl4j-lib.loc=file://$(build-classpath wsdl4j)
#   # javadoc generation
#   %{ant} -f dist.xml dist-prepare
#   %{ant} -f dist.xml dist-source
#   %{ant} -f dist.xml dist-javadoc
    # remove some jars that we'll replace with symlinks later
#   %{__rm} output/build/bin/commons-daemon.jar \
#           output/build/lib/ecj3.jar
#   # remove the cruft we created
#   %{__rm} output/build/bin/tomcat-native.tar.gz
#    find -name HACK -exec %{__rm} {} \;

popd
pushd %{packdname}/output/dist/src/webapps/docs/appdev/sample/src
%{__mkdir_p} ../web/WEB-INF/classes
%{javac} -cp ../../../../../../../../output/build/lib/servlet-api.jar \
    -d ../web/WEB-INF/classes mypackage/Hello.java
pushd ../web
%{jar} cf \
    ../../../../../../../../output/build/webapps/docs/appdev/sample/sample.war *
popd
popd

%install
%{__rm} -rf $RPM_BUILD_ROOT
# build initial path structure
%{__install} -d -m 0755 ${RPM_BUILD_ROOT}%{_bindir}
%{__install} -d -m 0755 ${RPM_BUILD_ROOT}%{_sbindir}
%{__install} -d -m 0755 ${RPM_BUILD_ROOT}%{_javadocdir}/%{name}
%{__install} -d -m 0755 ${RPM_BUILD_ROOT}%{_initrddir}
%{__install} -d -m 0755 ${RPM_BUILD_ROOT}%{_sysconfdir}/logrotate.d
%{__install} -d -m 0755 ${RPM_BUILD_ROOT}%{_sysconfdir}/sysconfig
%{__install} -d -m 0755 ${RPM_BUILD_ROOT}%{appdir}
%{__install} -d -m 0755 ${RPM_BUILD_ROOT}%{bindir}
%{__install} -d -m 0755 ${RPM_BUILD_ROOT}%{confdir}
%{__install} -d -m 0755 ${RPM_BUILD_ROOT}%{confdir}/Catalina/localhost
%{__install} -d -m 0755 ${RPM_BUILD_ROOT}%{libdir}
%{__install} -d -m 0755 ${RPM_BUILD_ROOT}%{logdir}
%{__install} -d -m 0755 ${RPM_BUILD_ROOT}%{homedir}
%{__install} -d -m 0755 ${RPM_BUILD_ROOT}%{tempdir}
%{__install} -d -m 0755 ${RPM_BUILD_ROOT}%{workdir}
# move things into place
pushd %{packdname}/output/build
    %{__mv} bin/tomcat-juli.jar ${RPM_BUILD_ROOT}%{libdir}/tomcat-juli.jar
    %{__ln_s} %{libdir}/tomcat-juli.jar ${RPM_BUILD_ROOT}%{bindir}/tomcat-juli.jar

    %{__cp} -a bin/*.{jar,xml} ${RPM_BUILD_ROOT}%{bindir}
    %{__cp} -a conf/*.{policy,properties,xml} ${RPM_BUILD_ROOT}%{confdir}
    %{__cp} -a lib/*.jar ${RPM_BUILD_ROOT}%{libdir}
    %{__cp} -a webapps/* ${RPM_BUILD_ROOT}%{appdir}
popd
pushd %{packdname}/output/extras
    %{__mv} tomcat-juli.jar tomcat-juli-extras.jar
    %{__cp} -a *.jar ${RPM_BUILD_ROOT}%{libdir}
popd
# javadoc
pushd %{packdname}/output/dist/webapps
    %{__cp} -a docs/api/* ${RPM_BUILD_ROOT}%{_javadocdir}/%{name}
popd
%{__sed} -e "s|\@\@\@TCHOME\@\@\@|%{homedir}|g" \
         -e "s|\@\@\@TCTEMP\@\@\@|%{tempdir}|g" \
         -e "s|\@\@\@LIBDIR\@\@\@|%{_libdir}|g" %{SOURCE1} \
    > ${RPM_BUILD_ROOT}%{confdir}/%{name}.conf
%{__sed} -e "s|\@\@\@TCHOME\@\@\@|%{homedir}|g" \
         -e "s|\@\@\@TCTEMP\@\@\@|%{tempdir}|g" \
         -e "s|\@\@\@LIBDIR\@\@\@|%{_libdir}|g" %{SOURCE3} \
    > ${RPM_BUILD_ROOT}%{_sysconfdir}/sysconfig/%{name}
%{__install} -m 0644 %{SOURCE2} \
    ${RPM_BUILD_ROOT}%{_initrddir}/%{name}
%{__install} -m 0644 %{SOURCE4} \
    ${RPM_BUILD_ROOT}%{_sbindir}/d%{name}
#%{__ln_s} %{name} ${RPM_BUILD_ROOT}%{_sbindir}/d%{name}
%{__install} -m 0644 %{SOURCE8} \
    ${RPM_BUILD_ROOT}%{_sbindir}/%{name}
%{__sed} -e "s|\@\@\@TCLOG\@\@\@|%{logdir}|g" %{SOURCE5} \
    > ${RPM_BUILD_ROOT}%{_sysconfdir}/logrotate.d/%{name}
%{__sed} -e "s|\@\@\@TCHOME\@\@\@|%{homedir}|g" \
         -e "s|\@\@\@TCTEMP\@\@\@|%{tempdir}|g" \
         -e "s|\@\@\@LIBDIR\@\@\@|%{_libdir}|g" %{SOURCE6} \
    > ${RPM_BUILD_ROOT}%{_bindir}/%{name}-digest
%{__sed} -e "s|\@\@\@TCHOME\@\@\@|%{homedir}|g" \
         -e "s|\@\@\@TCTEMP\@\@\@|%{tempdir}|g" \
         -e "s|\@\@\@LIBDIR\@\@\@|%{_libdir}|g" %{SOURCE7} \
    > ${RPM_BUILD_ROOT}%{_bindir}/%{name}-tool-wrapper
pushd ${RPM_BUILD_ROOT}%{_javadir}
    # create jsp and servlet and el API symlinks
    %{__mv} %{name}/jsp-api.jar %{name}-jsp-%{jspspec}-api-%{version}.jar
    %{__mv} %{name}/servlet-api.jar \
        %{name}-servlet-%{servletspec}-api-%{version}.jar
    %{__mv} %{name}/el-api.jar %{name}-el-%{elspec}-api-%{version}.jar
    /bin/touch el_2_2_api.jar
    /bin/touch el_api.jar
    /bin/touch jsp.jar
    /bin/touch jsp_api.jar
    /bin/touch jsp_2_2_api.jar
    /bin/touch servlet.jar
    /bin/touch servlet_api.jar
    /bin/touch servlet_3_0_api.jar
    %{__ln_s} %{name}-jsp-%{jspspec}-api-%{version}.jar \
        %{name}-jsp-%{jspspec}-api.jar
    %{__ln_s} %{name}-servlet-%{servletspec}-api-%{version}.jar \
        %{name}-servlet-%{servletspec}-api.jar
    %{__ln_s} %{name}-el-%{elspec}-api-%{version}.jar \
        %{name}-el-%{elspec}-api.jar
popd
pushd ${RPM_BUILD_ROOT}%{libdir}
    # fix up jars to include version number
    for i in *.jar; do
        j="$(echo $i | %{__sed} -e 's,\.jar$,,')"
        %{__mv} ${j}.jar ${j}-%{version}.jar
        %{__ln_s} ${j}-%{version}.jar ${j}.jar
    done
    # symlink JSP and servlet and el API jars
    %{__ln_s} ../%{name}-jsp-%{jspspec}-api-%{version}.jar .
    %{__ln_s} ../%{name}-servlet-%{servletspec}-api-%{version}.jar .
    %{__ln_s} ../%{name}-el-%{elspec}-api-%{version}.jar .
popd
pushd ${RPM_BUILD_ROOT}%{bindir}
    # fix up jars to include version number
    for i in *.jar; do
        j="$(echo $i | %{__sed} -e 's,\.jar$,,')"
        %{__mv} ${j}.jar ${j}-%{version}.jar
        %{__ln_s} ${j}-%{version}.jar ${j}.jar
    done
popd
# symlink to the FHS locations where we've installed things
pushd ${RPM_BUILD_ROOT}%{homedir}
    %{__ln_s} %{appdir} webapps
    %{__ln_s} %{confdir} conf
    %{__ln_s} %{libdir} lib
    %{__ln_s} %{logdir} logs
    %{__ln_s} %{tempdir} temp
    %{__ln_s} %{workdir} work
popd

# install sample webapp
%{__mkdir_p} ${RPM_BUILD_ROOT}%{appdir}/sample
pushd ${RPM_BUILD_ROOT}%{appdir}/sample
%{jar} xf ${RPM_BUILD_ROOT}%{appdir}/docs/appdev/sample/sample.war
popd
%{__rm} ${RPM_BUILD_ROOT}%{appdir}/docs/appdev/sample/sample.war

%{_bindir}/build-jar-repository ${RPM_BUILD_ROOT}%{libdir} \
    commons-collections-tomcat5 commons-dbcp-tomcat5 commons-pool-tomcat5 ecj3

# install poms and depmap frags
%{__mkdir_p} ${RPM_BUILD_ROOT}%{_datadir}/maven2/poms

#Source21: http://repo2.maven.org/maven2/org/apache/tomcat/tomcat-annotations-api/7.0.22/tomcat-annotations-api-7.0.22.pom
%{__install} -m 0644 %{SOURCE21} ${RPM_BUILD_ROOT}%{_datadir}/maven2/poms/JPP.tomcat7-annotations-api.pom
%add_to_maven_depmap org.apache.tomcat tomcat-annotations-api %{version} JPP/%{name} annotations-api
#Source22: http://repo2.maven.org/maven2/org/apache/tomcat/tomcat-api/7.0.22/tomcat-api-7.0.22.pom
%{__install} -m 0644 %{SOURCE22} ${RPM_BUILD_ROOT}%{_datadir}/maven2/poms/JPP.tomcat7-api.pom
%add_to_maven_depmap org.apache.tomcat tomcat-api %{version} JPP/%{name} api
#Source23: http://repo2.maven.org/maven2/org/apache/tomcat/tomcat-catalina/7.0.22/tomcat-catalina-7.0.22.pom
%{__install} -m 0644 %{SOURCE23} ${RPM_BUILD_ROOT}%{_datadir}/maven2/poms/JPP.tomcat7-catalina.pom
%add_to_maven_depmap org.apache.tomcat tomcat-catalina %{version} JPP/%{name} catalina
#Source24: http://repo2.maven.org/maven2/org/apache/tomcat/tomcat-catalina-ant/7.0.22/tomcat-catalina-ant-7.0.22.pom
%{__install} -m 0644 %{SOURCE24} ${RPM_BUILD_ROOT}%{_datadir}/maven2/poms/JPP.tomcat7-catalina-ant.pom
%add_to_maven_depmap org.apache.tomcat tomcat-catalina-ant %{version} JPP/%{name} catalina-ant
#Source25: http://repo2.maven.org/maven2/org/apache/tomcat/tomcat-catalina-ha/7.0.22/tomcat-catalina-ha-7.0.22.pom
%{__install} -m 0644 %{SOURCE25} ${RPM_BUILD_ROOT}%{_datadir}/maven2/poms/JPP.tomcat7-catalina-ha.pom
%add_to_maven_depmap org.apache.tomcat tomcat-catalina-ha %{version} JPP/%{name} catalina-ha
#Source26: http://repo2.maven.org/maven2/org/apache/tomcat/tomcat-catalina-jmx-remote/7.0.22/tomcat-catalina-jmx-remote-7.0.22.pom
%{__install} -m 0644 %{SOURCE26} ${RPM_BUILD_ROOT}%{_datadir}/maven2/poms/JPP.tomcat7-catalina-jmx-remote.pom
%add_to_maven_depmap org.apache.tomcat tomcat-catalina-jmx-remote %{version} JPP/%{name} catalina-jmx-remote
#Source27: http://repo2.maven.org/maven2/org/apache/tomcat/tomcat-catalina-ws/7.0.22/tomcat-catalina-ws-7.0.22.pom
%{__install} -m 0644 %{SOURCE27} ${RPM_BUILD_ROOT}%{_datadir}/maven2/poms/JPP.tomcat7-catalina-ws.pom
%add_to_maven_depmap org.apache.tomcat tomcat-catalina-ws %{version} JPP/%{name} catalina-ws
#Source28: http://repo2.maven.org/maven2/org/apache/tomcat/tomcat-coyote/7.0.22/tomcat-coyote-7.0.22.pom
%{__install} -m 0644 %{SOURCE28} ${RPM_BUILD_ROOT}%{_datadir}/maven2/poms/JPP.tomcat7-coyote.pom
%add_to_maven_depmap org.apache.tomcat tomcat-coyote %{version} JPP/%{name} coyote
#Source29: http://repo2.maven.org/maven2/org/apache/tomcat/tomcat-dbcp/7.0.22/tomcat-dbcp-7.0.22.pom
%{__install} -m 0644 %{SOURCE29} ${RPM_BUILD_ROOT}%{_datadir}/maven2/poms/JPP.tomcat7-dbcp.pom
%add_to_maven_depmap org.apache.tomcat tomcat-dbcp %{version} JPP/%{name} dbcp
#Source30: http://repo2.maven.org/maven2/org/apache/tomcat/tomcat-el-api/7.0.22/tomcat-el-api-7.0.22.pom
%{__install} -m 0644 %{SOURCE30} ${RPM_BUILD_ROOT}%{_datadir}/maven2/poms/JPP.tomcat7-el-api.pom
%add_to_maven_depmap org.apache.tomcat tomcat-el-api %{version} JPP/%{name} el-api
#Source31: http://repo2.maven.org/maven2/org/apache/tomcat/tomcat-i18n-es/7.0.22/tomcat-i18n-es-7.0.22.pom
%{__install} -m 0644 %{SOURCE31} ${RPM_BUILD_ROOT}%{_datadir}/maven2/poms/JPP.tomcat7-i18n-es.pom
%add_to_maven_depmap org.apache.tomcat tomcat-i18n-es %{version} JPP/%{name} i18n-es
#Source32: http://repo2.maven.org/maven2/org/apache/tomcat/tomcat-i18n-fr/7.0.22/tomcat-i18n-fr-7.0.22.pom
%{__install} -m 0644 %{SOURCE32} ${RPM_BUILD_ROOT}%{_datadir}/maven2/poms/JPP.tomcat7-i18n-fr.pom
%add_to_maven_depmap org.apache.tomcat tomcat-i18n-fr %{version} JPP/%{name} i18n-fr
#Source33: http://repo2.maven.org/maven2/org/apache/tomcat/tomcat-i18n-ja/7.0.22/tomcat-i18n-ja-7.0.22.pom
%{__install} -m 0644 %{SOURCE33} ${RPM_BUILD_ROOT}%{_datadir}/maven2/poms/JPP.tomcat7-i18n-ja.pom
%add_to_maven_depmap org.apache.tomcat tomcat-i18n-ja %{version} JPP/%{name} i18n-ja
#Source35: http://repo2.maven.org/maven2/org/apache/tomcat/tomcat-jasper/7.0.22/tomcat-jasper-7.0.22.pom
%{__install} -m 0644 %{SOURCE35} ${RPM_BUILD_ROOT}%{_datadir}/maven2/poms/JPP.tomcat7-jasper.pom
%add_to_maven_depmap org.apache.tomcat tomcat-jasper %{version} JPP/%{name} jasper
#Source36: http://repo2.maven.org/maven2/org/apache/tomcat/tomcat-jasper-el/7.0.22/tomcat-jasper-el-7.0.22.pom
%{__install} -m 0644 %{SOURCE36} ${RPM_BUILD_ROOT}%{_datadir}/maven2/poms/JPP.tomcat7-jasper-el.pom
%add_to_maven_depmap org.apache.tomcat tomcat-jasper-el %{version} JPP/%{name} jasper-el
#Source37: http://repo2.maven.org/maven2/org/apache/tomcat/tomcat-jdbc/7.0.22/tomcat-jdbc-7.0.22.pom
%{__install} -m 0644 %{SOURCE37} ${RPM_BUILD_ROOT}%{_datadir}/maven2/poms/JPP.tomcat7-jdbc.pom
%add_to_maven_depmap org.apache.tomcat tomcat-jdbc %{version} JPP/%{name} jdbc
#Source38: http://repo2.maven.org/maven2/org/apache/tomcat/tomcat-jsp-api/7.0.22/tomcat-jsp-api-7.0.22.pom
%{__install} -m 0644 %{SOURCE38} ${RPM_BUILD_ROOT}%{_datadir}/maven2/poms/JPP.tomcat7-jsp-api.pom
%add_to_maven_depmap org.apache.tomcat tomcat-jsp-api %{version} JPP/%{name} jsp-api
#Source39: http://repo2.maven.org/maven2/org/apache/tomcat/tomcat-juli/7.0.22/tomcat-juli-7.0.22.pom
%{__install} -m 0644 %{SOURCE39} ${RPM_BUILD_ROOT}%{_datadir}/maven2/poms/JPP.tomcat7-juli.pom
%add_to_maven_depmap org.apache.tomcat tomcat-juli %{version} JPP/%{name} juli
#Source40: http://repo2.maven.org/maven2/org/apache/tomcat/tomcat-servlet-api/7.0.22/tomcat-servlet-api-7.0.22.pom
%{__install} -m 0644 %{SOURCE40} ${RPM_BUILD_ROOT}%{_datadir}/maven2/poms/JPP.tomcat7-servlet-api.pom
%add_to_maven_depmap org.apache.tomcat tomcat-servlet-api %{version} JPP/%{name} servlet-api
#Source41: http://repo2.maven.org/maven2/org/apache/tomcat/tomcat-tribes/7.0.22/tomcat-tribes-7.0.22.pom
%{__install} -m 0644 %{SOURCE41} ${RPM_BUILD_ROOT}%{_datadir}/maven2/poms/JPP.tomcat7-tribes.pom
%add_to_maven_depmap org.apache.tomcat tomcat-tribes %{version} JPP/%{name} tribes
#Source42: http://repo2.maven.org/maven2/org/apache/tomcat/tomcat-util/7.0.22/tomcat-util-7.0.22.pom
%{__install} -m 0644 %{SOURCE42} ${RPM_BUILD_ROOT}%{_datadir}/maven2/poms/JPP.tomcat7-util.pom
%add_to_maven_depmap org.apache.tomcat tomcat-util %{version} JPP/%{name} util


%clean
%{__rm} -rf $RPM_BUILD_ROOT

%pre
# add the tomcat user and group
%{_sbindir}/groupadd -g %{tcuid} -r tomcat 2>/dev/null || :
%{_sbindir}/useradd -c "Apache Tomcat" -u %{tcuid} -g tomcat \
    -s /bin/sh -r -d %{homedir} tomcat 2>/dev/null || :

%post
%update_maven_depmap
# install but don't activate
/sbin/chkconfig --add %{name}

%postun
%update_maven_depmap

%post el-2.2-api
%{_sbindir}/update-alternatives --install %{_javadir}/el_api.jar \
    el_api %{_javadir}/%{name}-el-%{elspec}-api.jar 20200
%{_sbindir}/update-alternatives --install %{_javadir}/el_2_2_api.jar \
    el_2_2_api %{_javadir}/%{name}-el-%{elspec}-api.jar 20200

%preun el-2.2-api
if [ "$1" = "0" ]; then
    %{_sbindir}/update-alternatives --remove el_api \
        %{_javadir}/%{name}-el-%{elspec}-api.jar
    %{_sbindir}/update-alternatives --remove el_2_2_api \
        %{_javadir}/%{name}-el-%{elspec}-api.jar
fi

%post jsp-%{jspspec}-api
%{_sbindir}/update-alternatives --install %{_javadir}/jsp.jar jsp \
    %{_javadir}/%{name}-jsp-%{jspspec}-api.jar 20200
%{_sbindir}/update-alternatives --install %{_javadir}/jsp_api.jar jsp_api \
    %{_javadir}/%{name}-jsp-%{jspspec}-api.jar 20200
%{_sbindir}/update-alternatives --install %{_javadir}/jsp_2_2_api.jar jsp_2_2_api \
    %{_javadir}/%{name}-jsp-%{jspspec}-api.jar 20200

%post servlet-%{servletspec}-api
%{_sbindir}/update-alternatives --install %{_javadir}/servlet.jar servlet \
    %{_javadir}/%{name}-servlet-%{servletspec}-api.jar 30000
%{_sbindir}/update-alternatives --install %{_javadir}/servlet_api.jar servlet_api \
    %{_javadir}/%{name}-servlet-%{servletspec}-api.jar 30000
%{_sbindir}/update-alternatives --install %{_javadir}/servlet_3_0_api.jar servlet_3_0_api \
    %{_javadir}/%{name}-servlet-%{servletspec}-api.jar 30000

%post webapps
# need to use -p here with b-j-r otherwise the examples webapp fails to
# load with a java.io.IOException
%{_bindir}/build-jar-repository -p %{appdir}/examples/WEB-INF/lib \
    taglibs-core.jar taglibs-standard.jar 2>&1

%preun
# clean tempdir and workdir on removal or upgrade
%{__rm} -rf %{workdir}/* %{tempdir}/*
if [ "$1" = "0" ]; then
    %{_initrddir}/%{name} stop >/dev/null 2>&1
    /sbin/chkconfig --del %{name}
fi

%preun lib
if [ "$1" = "0" ]; then
    %{__rm} -f %{libdir}/\[commons-collections-tomcat5\].jar \
        %{libdir}/\[commons-dbcp-tomcat5\].jar \
        %{libdir}/\[commons-pool-tomcat5\].jar \
        %{libdir}/\[ecj\].jar >/dev/null 2>&1
fi

%preun webapps
if [ "$1" = "0" ]; then
    # these do not have brackets due to b-j-r -p usage
    %{__rm} %{appdir}/examples/WEB-INF/lib/taglibs-core.jar \
        %{appdir}/examples/WEB-INF/lib/taglibs-standard.jar
fi

%postun jsp-%{jspspec}-api
if [ "$1" = "0" ]; then
    %{_sbindir}/update-alternatives --remove jsp \
        %{_javadir}/%{name}-jsp-%{jspspec}-api.jar
    %{_sbindir}/update-alternatives --remove jsp_api \
        %{_javadir}/%{name}-jsp-%{jspspec}-api.jar
    %{_sbindir}/update-alternatives --remove jsp_2_2_api \
        %{_javadir}/%{name}-jsp-%{jspspec}-api.jar
fi

%postun servlet-%{servletspec}-api
if [ "$1" = "0" ]; then
    %{_sbindir}/update-alternatives --remove servlet \
        %{_javadir}/%{name}-servlet-%{servletspec}-api.jar
    %{_sbindir}/update-alternatives --remove servlet_api \
        %{_javadir}/%{name}-servlet-%{servletspec}-api.jar
    %{_sbindir}/update-alternatives --remove servlet_3_0_api \
        %{_javadir}/%{name}-servlet-%{servletspec}-api.jar
fi

%files
%defattr(0644,root,root,0755)
%doc %{packdname}/{LICENSE,NOTICE,RELEASE*}
%attr(0755,root,root) %{_bindir}/%{name}-digest
%attr(0755,root,root) %{_bindir}/%{name}-tool-wrapper
%attr(0755,root,root) %{_sbindir}/d%{name}
%attr(0755,root,root) %{_sbindir}/%{name}
%attr(0775,root,tomcat) %dir %{logdir}
%attr(0755,root,root) %{_initrddir}/%{name}
%attr(0644,root,root) %config(noreplace) %{_sysconfdir}/logrotate.d/%{name}
%config(noreplace) %{_sysconfdir}/sysconfig/%{name}
%dir %{basedir}
%attr(0775,root,tomcat) %dir %{appdir}
%dir %{confdir}
%dir %{confdir}/Catalina
%attr(0775,root,tomcat) %dir %{confdir}/Catalina/localhost
%config(noreplace) %{confdir}/%{name}.conf
%config(noreplace) %{confdir}/*.policy
%config(noreplace) %{confdir}/*.properties
%config(noreplace) %{confdir}/context.xml
%config(noreplace) %{confdir}/server.xml
%attr(0660,root,tomcat) %config(noreplace) %{confdir}/tomcat-users.xml
%config(noreplace) %{confdir}/web.xml
%attr(0775,root,tomcat) %dir %{cachedir}
%attr(0775,root,tomcat) %dir %{tempdir}
%attr(0775,root,tomcat) %dir %{workdir}
%{homedir}
%{_datadir}/maven2/poms/*
%{_mavendepmapfragdir}/*


%files admin-webapps
%defattr(0644,root,root,0755)
%{appdir}/host-manager
%{appdir}/manager

%files docs-webapp
%defattr(0644,root,root,0755)
%{appdir}/docs

%files el-%{elspec}-api
%defattr(0644,root,root,0755)
%{_javadir}/%{name}-el-%{elspec}-api-%{version}.jar
%{_javadir}/%{name}-el-%{elspec}-api.jar
%ghost %{_javadir}/el_2_2_api.jar
%ghost %{_javadir}/el_api.jar

%files javadoc
%defattr(0644,root,root,0755)
%{_javadocdir}/%{name}

%files jsp-%{jspspec}-api
%defattr(0644,root,root,0755)
%{_javadir}/%{name}-jsp-%{jspspec}-api-%{version}.jar
%{_javadir}/%{name}-jsp-%{jspspec}-api.jar
%ghost %{_javadir}/jsp.jar
%ghost %{_javadir}/jsp_2_2_api.jar
%ghost %{_javadir}/jsp_api.jar

%files lib
%defattr(0644,root,root,0755)
%{libdir}

%files servlet-%{servletspec}-api
%defattr(0644,root,root,0755)
%{_javadir}/%{name}-servlet-%{servletspec}-api-%{version}.jar
%{_javadir}/%{name}-servlet-%{servletspec}-api.jar
%ghost %{_javadir}/servlet.jar
%ghost %{_javadir}/servlet_3_0_api.jar
%ghost %{_javadir}/servlet_api.jar

%files webapps
%defattr(0644,root,root,0755)
%{appdir}/ROOT
%{appdir}/examples
%{appdir}/sample

%changelog
* Fri Nov 18 2011 Ralph Apel <r.apel@r-apel.de> 0:7.0.22-1
- 7.0.22

